<template>
  <b-container>
    <GoBack />
    <div class="background_bloc" />
    <h1 class="title">
      {{ categorie }}
    </h1>
  </b-container>
  <b-container>
    <div class="d-md-flex align-items-center justify-content-end w-100 mb-4">
      <div class="mx-2">
        Filtrer :
      </div>
      <div class="d-flex flex-wrap">
        <button
          class="btn-cta btn-filter mx-1"
          @click="filterBy('[prix]=asc')"
        >
          Prix croissant
        </button>
        <button
          class="btn-cta btn-filter mx-1"
          @click="filterBy('[prix]=desc')"
        >
          Prix décroissant
        </button>
        <button
          class="btn-cta btn-filter mx-1"
          @click="filterBy('[id]=desc')"
        >
          Date de publication
        </button>
      </div>
    </div>

    <b-row v-if="produits.length">
      <b-col 
        v-for="(produit, index) in produits"
        :key="produit"
        sm="12"
        md="4"
      >
        <NomVendeur :id="produit.vendeur.id" />
        <CardProduit
          :id="produit.id"
          :id-vendeur="produit.vendeur.id"
          :titre="produit.titre"
          :prix="produit.prix"
          :image="images[index]"
        />
      </b-col>
      <button
        v-if="currentPage < nbTotalPages"
        class="btn-cta load-more"
        :data-page="currentPage"
        @click="loadMore()"
      >
        Charger plus
      </button>
    </b-row>
    <p v-else>
      Il n'y a pas de produit pour cette catégorie
    </p>
  </b-container>
</template>

<script>
import { useStore } from '@/store/store'
import axios from 'axios'
import CardProduit from '@/components/CardProduit.vue'
import NomVendeur from '@/components/NomVendeur.vue'
import GoBack from '@/components/GoBack.vue'



export default {

    components: {
      NomVendeur,
      CardProduit,
      GoBack
    },

    data() {;
        return {
            url: process.env.VUE_APP_URL,
            store: useStore(),
            produits: [],
            categorie: '',
            images: [],
            nbTotalPages: '',
            currentPage: '1',
            filter: ''
        }
    },

    watch: {
        '$route.params.cat': function () {
            this.loadData();
        },
    },

    mounted() {
        this.loadData();
    },

    methods: {

      loadData(){
        this.filter = '';
        axios.get(this.url + "/api/produits?order[id]=desc&categorie=" + this.$route.params.cat)
            .then(res => {
              console.log(res.data);
                this.categorie = res.data.nom;
                console.log(res.data);
                if(res.data['hydra:member'].length > 0){
                  res.data['hydra:member'].forEach(produit => {
                    if(produit.mediaObjects[0] == undefined){
                        this.images.push('noimg');
                    } else {
                        this.images.push(produit.mediaObjects[0].contentUrl);
                    }
                    this.produits.push(produit);
                    })
            }
        });
        axios.get(this.url + "/api/categories/" + this.$route.params.cat)
        .then(res => {
            this.categorie = res.data.nom;
        })
        .catch(err => {
            console.log(err);
        })
      },

      loadMore(){
        if(this.filter == ''){
                this.filter = '[id]=desc';
            }
            this.currentPage = parseInt(this.currentPage) + 1;
            axios.get(this.url + "/api/produits?order" + this.filter + "&categorie=" + this.$route.params.cat + '&page=' + this.currentPage)
            .then(res => {
                let arr = res.data['hydra:member'];
                for (let i = 0; i < arr.length; i++) {
                    const produit = arr[i];
                    if(produit.mediaObjects[0] == undefined){
                        this.images.push('noimg');
                    } else {
                        this.images.push(produit.mediaObjects[0].contentUrl);
                    }
                    this.produits.push(produit);
                }
            })
            .catch(err => {
              console.log(err);
            })
        },

        filterBy(filter){
            this.filter = filter;
            this.produits = [];
            this.images = [];
            axios.get(this.url + "/api/produits?order" + this.filter + "&categorie=" + this.$route.params.cat)
            .then(res => {
                    let arr = res.data['hydra:member'];
                    if(res.data['hydra:totalItems'] > 15){
                        this.nbTotalPages = Math.ceil(res.data['hydra:totalItems'] / 15);
                    }
                    for (let i = 0; i < arr.length; i++) {
                        const produit = arr[i];
                        if(produit.mediaObjects[0] == undefined){
                            this.images.push('noimg');
                        } else {
                            this.images.push(produit.mediaObjects[0].contentUrl);
                        }
                        this.produits.push(produit);
                    }
                })
        }
    }
}
</script>
